<?php
/*
Plugin Name: Polaroid on the Fly
Plugin URI: http://sivel.net/wordpress/
Description: Creates polaroids of images on the fly for thumbnails in posts. Support for lightbox included. Built on modified Polaroidgen-polaroidr v0.7.2 sources.
Version: 0.4
Author: Matt Martz
Author URI: http://sivel.net

        Copyright (c) 2007 Matt Martz (http://sivel.net)
        Polaroid on the Fly is released under the GNU General Public License (GPL)
        http://www.gnu.org/licenses/gpl.txt

        This is a WordPress 2 plugin (http://wordpress.org).
	Polaroid-o-nizer is licensed under the GNU General Public License (GPL)
	http://www.gnu.org/licenses/gpl.txt
*/

// Initialize Globabl variables
$plugin_name = dirname(plugin_basename(__FILE__));
$siteurl = get_option('siteurl');
$plugin_uri = 'wp-content/plugins/' . $plugin_name . '/';
$plugin_url = $siteurl . '/' . $plugin_uri;

### Create Text Domain For Translations
load_plugin_textdomain('polaroid-on-the-fly', 'wp-content/plugins/polaroid-on-the-fly');

### Function: potf Option Menu
add_action('admin_menu', 'potf_menu');
function potf_menu() {
        if (function_exists('add_options_page')) {
                add_options_page(__('Polaroid on the Fly', 'polaroid-on-the-fly'), __('Polaroid on the Fly', 'polaroid-on-the-fly'), 'manage_options', 'polaroid-on-the-fly/polaroid-on-the-fly.php', 'potf_options');
        }
}

### Function: Options Page
function potf_options() {
        global $wpdb;
        $text = '';
        $potf_options = array();
        $potf_options = get_option('potf_options');
        if($_POST['Submit']) {
                $potf_options['secure'] = intval($_POST['secure']);
                $potf_options['tinyurl'] = intval($_POST['tinyurl']);
		$potf_options['caption'] = intval($_POST['caption']);
                $potf_options['bg'] = trim($_POST['bg']);
                $update_potf_options = update_option('potf_options', $potf_options);
                if($update_potf_options) {
                        $text = '<font color="green">'.__('Polaroid on the Fly Options Updated', 'polaroid-on-the-fly').'</font>';
                }
                if(empty($text)) {
                        $text = '<font color="red">'.__('No Polaroid on the Fly Option Updated', 'polaroid-on-the-fly').'</font>';
                }
        }
?>
<?php if(!empty($text)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$text.'</p></div>'; } ?>
<!--potf Options -->
<div class="wrap">
        <h2><?php _e('Polaroid on the Fly Options', 'polaroid-on-the-fly'); ?></h2>
        <form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
                <table width="100%" cellspacing="3" cellpadding="3" border="0">
                        <tr>
                                <td valign="top"><strong><?php _e('Enable Security:', 'polaroid-on-the-fly'); ?></strong></td>
                                <td>
                                        <select name="secure">
                                                <option value="0"<?php selected('0', $potf_options['secure']); ?>><?php _e('No', 'polaroid-on-the-fly'); ?></option>
                                                <option value="1"<?php selected('1', $potf_options['secure']); ?>><?php _e('Yes', 'polaroid-on-the-fly'); ?></option>
                                        </select>
                                        <br /><?php _e('Protect this plugin from being used by remote users/websites.', 'polaroid-on-the-fly'); ?>
                                </td>
                        </tr>
                        <tr>
                                <td valign="top"><strong><?php _e('Use Tinyurl.com:', 'polaroid-on-the-fly'); ?></strong></td>
                                <td>
                                        <select name="tinyurl">
                                                <option value="0"<?php selected('0', $potf_options['tinyurl']); ?>><?php _e('No', 'polaroid-on-the-fly'); ?></option>
                                                <option value="1"<?php selected('1', $potf_options['tinyurl']); ?>><?php _e('Yes', 'polaroid-on-the-fly'); ?></option>
                                        </select>
                                        <br /><?php _e('Use tinyurl.com to hide the location of the image.  If fopen is not enabled in php on your server set this to \'No\'.', 'polaroid-on-the-fly'); ?>
                                </td>
                        </tr>
                        <tr>
                                <td valign="top"><strong><?php _e('Use Image Captions:', 'polaroid-on-the-fly'); ?></strong></td>
                                <td>
                                        <select name="caption">
                                                <option value="0"<?php selected('0', $potf_options['caption']); ?>><?php _e('No', 'polaroid-on-the-fly'); ?></option>
                                                <option value="1"<?php selected('1', $potf_options['caption']); ?>><?php _e('Yes', 'polaroid-on-the-fly'); ?></option>
                                        </select>
                                        <br /><?php _e('Display image captions below picture on polaroid. This uses the alt text from the img tag.  NOTE: Because of the size all Captions will be truncated at 8 characters.', 'polaroid-on-the-fly'); ?>
                                </td>
                        </tr>
                        <tr>
                                <td valign="top"><strong><?php _e('Background Color:', 'polaroid-on-the-fly'); ?></strong></td>
                                <td>
                                        <input type="text" name="bg" size="60" value="<?php echo htmlentities($potf_options['bg']); ?>" />
                                        <br /><?php _e('This is the background color of your blog in RGB format.  See http://www.w3schools.com/html/html_colors.asp for help.', 'polaroid-on-the-fly'); ?>
                                </td>
                        </tr>
                        <tr>
                                <td width="100%" colspan="2" align="center"><input type="submit" name="Submit" class="button" value="<?php _e('Update Options', 'polaroid-on-the-fly'); ?>" />&nbsp;&nbsp;<input type="button" name="cancel" value="<?php _e('Cancel', 'polaroid-on-the-fly'); ?>" class="button" onclick="javascript:history.go(-1)" /></td>
                        </tr>
                </table>

        </form>
<?php
}

### Function: Get potf Option
function get_potf_option($option) {
        $potf_options = get_option('potf_options');
        return $potf_options[$option];
}

### Function: potf Init
add_action('activate_polaroid-on-the-fly/polaroid-on-the-fly.php', 'potf_init');
function potf_init() {
        global $wpdb;
        include_once(ABSPATH.'/wp-admin/upgrade-functions.php');
        // Delete Options First
        potf_delete();
        // Add Options
        $potf_options = array();
        $potf_options['secure'] = 1;
        $potf_options['tinyurl'] = 0;
	$potf_options['caption'] = 0;
        $potf_options['bg'] = '255,255,255';
        add_option('potf_options', $potf_options, 'Polaroid on the Fly Options');
}

### Function: delete options
function potf_delete() {
	delete_option('potf_options');
}

// Begin function to replace text
function polaroid_replace($potf_page_content) {

	// Import Global Variables
	GLOBAL $plugin_name, $siteurl, $plugin_uri, $plugin_url;

	// Define Search Paramenters
	$search = '/(<p\>)?<img(.*)?src\=[\'|"](.*)\.(jpg|jpeg|gif|png)(\?.*)?[\'|"]\ (.*)?rel\=[\'|"]polaroid[\'|"](.*)((alt\=[\'|"](.*)[\'|"]))?(.*)?(\/)?\>(<\/p\>)?/i';

	// Check the page content for matches
	if (preg_match_all($search, $potf_page_content, $matches, PREG_SET_ORDER)) {

		// Loop through each match
        	foreach ($matches as $match) :

			// Grab and format originally passed image url
                	preg_match('/src\=[\'|"](.*)\.(jpg|jpeg|gif|png)(\?.*)?[\'|"]\ /',$match[0],$url_results);
	                $url_orig = preg_replace('/(src\=)?[\'|"](\ )?/', '', $url_results[0]);

			// Grab and format orignally passed alt text
        	        preg_match('/alt\=[\'|"](.*)[\'|"]/',$match[0],$alt_results);
	                $alt_orig = preg_replace('/(alt\=)?[\'|"]/', '', $alt_results[0]);
        	        $alt_nolight = preg_replace('/\[(.*)\]/', '', $alt_orig);

			// Grab album name
			preg_match('/\[(.*)\]/', $alt_orig, $album_results);
			$album = $album_results[0];		
	
			// Run tinyutl.com api and grab the shortened url
			if (get_potf_option('tinyurl') == 1) {
		                $url_handle = fopen("http://tinyurl.com/api-create.php?url=" . $url_orig, "r");
        		        $url = fread($url_handle, 1024*1024);
                		fclose($url_handle);
			} else {
				$url = $url_orig;
			}

			// Create encoded part of URL for final polaroid image link
			if (get_potf_option('caption') == 1) {
				$encoded = base64_encode(get_potf_option('bg') . "||" . $url . "||0||0||0||" . substr_replace($alt_nolight, '', 8, 1024));
			} else {
		                $encoded = base64_encode(get_potf_option('bg') . "||" . $url . "||0||0||0||");
			}
			// Define Repalce Paramenters
        	        $replace = '<a href="' . $url . '" rel="lightbox' . $album . '" title="' . $alt_nolight . '"><img src="' . $plugin_url . 'gen-polaroid.php?img=' . $encoded . '" alt="' . $alt_nolight . '" height=150 width=123 border=0 /></a>';

			// Make replacements
			$potf_page_content = str_replace($match[0], $replace, $potf_page_content);

	        endforeach;
	}
	
	// Return the modified page content
	return $potf_page_content;
}

// Add filter to Wordpress to make substitutions from above function
add_filter('the_content', 'polaroid_replace');
?>
